SystemOrganization addCategory: #MkExperiments!

StandardWindow subclass: #MkMultiThreadedCounter
	instanceVariableNames: 'counterLabel process counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkExperiments'!

!MkMultiThreadedCounter methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/8/2010 09:27'!
counterLabel 
	^ counterLabel.! !

!MkMultiThreadedCounter methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/8/2010 09:29'!
initialize
	super initialize.
	self initializeGUI;
		initializeCounterProcess.! !

!MkMultiThreadedCounter methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/8/2010 09:35'!
initializeCounterProcess
	process := [[ true ] whileTrue: [
		(Delay forSeconds: 1) wait.
		self stepCounter.
	]] fork.
	process name: 'Counter Process'.! !

!MkMultiThreadedCounter methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/8/2010 09:33'!
initializeGUI
	self
		setLabel: 'Multi-threading experiment';
		addMorph: (self newLabel: '=== Test 1 ===') frame: (0 @ 0 corner: 0.5 @ 0.5);
		addMorph: (self newLabel: '-- Test 2 ---') frame: (0.5 @ 0 corner: 1 @ 0.5).
	counter := 0.
	counterLabel := self newLabel: '--'.
	self addMorph: counterLabel frame: (0 @ 0.5 corner: 1 @ 1)! !

!MkMultiThreadedCounter methodsFor: 'action' stamp: 'MathiasKegelmann 3/8/2010 09:34'!
stepCounter
	counter := counter + 1.
	WorldState addDeferredUIMessage: [
		counterLabel contents: counter asString
		].! !

Object subclass: #DinoParkSemaphoreExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkExperiments'!

!DinoParkSemaphoreExample class methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 3/12/2011 20:52'!
run
| ms cw vw |

ms := Semaphore new.
5 timesRepeat: [ms signal].

cw := Semaphore new.
3 timesRepeat: [cw signal].

vw := Semaphore new.

3 timesRepeat: [[ [
		vw wait. 
		Transcript crShow: 'Taking visitor around'.
		cw signal.
		] repeat] fork.].

(1 to: 20) do: [ :i | [
		ms wait.
		Transcript crShow: i asString, ' visiting museum'.
		vw signal.
		cw wait.
		ms signal.
		Transcript crShow: i asString, ' visiting park'.
		] fork.].! !

Object subclass: #MkEchoListener
	instanceVariableNames: 'connectionQueue process servers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkExperiments'!

!MkEchoListener methodsFor: 'private' stamp: 'MathiasKegelmann 4/16/2011 14:43'!
checkForConnection
	[ |s|
		s := connectionQueue getConnectionOrNil.
		s ifNotNil: [ servers add: (self startServer: s)].
		(Delay forMilliseconds: 100) wait
	] repeat.! !

!MkEchoListener methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/5/2011 00:56'!
destroy
	process ifNotNil: [
		process terminate.
		process := nil ].
	servers do: [ :server | server terminate].
	servers := OrderedCollection new.
	connectionQueue ifNotNil: [
		connectionQueue destroy.
		connectionQueue := nil]
	! !

!MkEchoListener methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/5/2011 00:13'!
initialize 
	servers := OrderedCollection new.! !

!MkEchoListener methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/6/2011 16:34'!
startListening
	self startListening: 9876.
! !

!MkEchoListener methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/6/2011 16:33'!
startListening: port
	"Set up a connection queue and start listening in an independent thread"
	connectionQueue := ConnectionQueue portNumber: port queueLength: 5.
	process := [self checkForConnection] fork.
	process name: 'Echo Server Connection Listener'.! !

!MkEchoListener methodsFor: 'private' stamp: 'MathiasKegelmann 4/16/2011 14:52'!
startServer: socket
	| server |
	server := MkEchoServer onSocket: socket.
	server start.
	^ server! !

!MkEchoListener methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/6/2011 16:42'!
terminate
	"Alias"
	self destroy.! !

Object subclass: #MkEchoServer
	instanceVariableNames: 'process socketStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkExperiments'!

!MkEchoServer class methodsFor: 'instance creation' stamp: 'MathiasKegelmann 4/16/2011 14:48'!
onSocket: socket
	|server|
	server := self basicNew.
	server initialize: socket.
	^ server! !

!MkEchoServer methodsFor: 'initialization' stamp: 'MathiasKegelmann 3/7/2011 08:25'!
initialize: aSocket
	socketStream := SocketStream on: aSocket.
	socketStream autoFlush: true; noTimeout.
	! !

!MkEchoServer methodsFor: 'private' stamp: 'MathiasKegelmann 3/7/2011 08:29'!
serve
	| line |
	[[socketStream atEnd]
		whileFalse: [line := socketStream nextLineLf.
			socketStream nextPutAll: line;
				 flush]]
		on: ConnectionClosed
		do: ["OK"
			].
	socketStream close! !

!MkEchoServer methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/6/2011 17:04'!
start
	socketStream nextPutAll: 'Connected.'; flush.
	process := [ self serve ] fork.
	process name: 'MkEchoServer'.! !

!MkEchoServer methodsFor: 'accessing' stamp: 'MathiasKegelmann 3/5/2011 00:39'!
terminate
	process ifNotNil: [
		process terminate.
		process := nil].
	socketStream close.! !

Object subclass: #MkNotes
	instanceVariableNames: 'a'
	classVariableNames: 'A B'
	poolDictionaries: ''
	category: 'MkExperiments'!

!MkNotes commentStamp: '<historical>' prior: 0!
Squeak Source Repositories:
MCHttpRepository
    location: 'http://www.squeaksource.com/MkPharoMisc'
    user: 'mkege'
    password: '13pihr2'
MCHttpRepository
	location: 'http://www.squeaksource.com/NoeTables'
	user: 'mkege'
	password: '13pihr2'!

!MkNotes class methodsFor: 'notes' stamp: 'MathiasKegelmann 2/27/2011 13:50'!
autotest
Gofer new
    squeaksource: 'Autotest';
    package: 'ConfigurationOfAutotest';
    load.

"Needed to load this using Monticello."

(ConfigurationOfAutotest project version:'1.0') load: 'Dev'.! !

!MkNotes class methodsFor: 'initialize-release' stamp: 'MathiasKegelmann 6/1/2011 12:18'!
initialize
	"A small test with class variables"
	A := 65.
	B := 66.! !

!MkNotes class methodsFor: 'notes' stamp: 'MathiasKegelmann 5/7/2011 14:44'!
mocketry
	ConfigurationOfMocketry project load: '1.0'.! !

!MkNotes class methodsFor: 'notes' stamp: 'MathiasKegelmann 10/15/2010 20:03'!
standardProcesses
	"As seen in Process Browser"
	^'
(80)	Delay clas>>handleTimerEvent
(60)	the low space watcher
(60)	Input events fetching process: [] in Delay>>wait
(50)	the WeakArray finalization process
(40s)	the UI process
(19)	the idle process
'! !

!MkNotes class methodsFor: 'tests' stamp: 'MathiasKegelmann 6/1/2011 12:19'!
testClassVars 
	^ A + B! !

!MkNotes methodsFor: 'initialize-release' stamp: 'MathiasKegelmann 11/2/2011 13:43'!
initialize 
	a := 42.! !

!MkNotes methodsFor: 'tests' stamp: 'MathiasKegelmann 6/1/2011 12:20'!
testClassVars 
	^ A * B! !

MkNotes subclass: #MkNotesSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkExperiments'!

!MkNotesSubclass methodsFor: 'as yet unclassified' stamp: 'MathiasKegelmann 11/2/2011 13:44'!
accessSuperclassField
	"This is legal in Smalltalk, i.e. member variables have 'protected' scope.'"
	^a! !
MkNotes initialize!
